#!/bin/bash

COUNTRY_CODE="TH"
PORT="8800"
IP_FILE="${COUNTRY_CODE}_ipv4.txt"

# 为每个 IP 地址移除防火墙规则
if [ -f "$IP_FILE" ]; then
    while IFS= read -r line
    do
        ip=$(echo "$line" | cut -d'|' -f1)
        count=$(echo "$line" | cut -d'|' -f2)
        mask=$(( 32 - $(echo "l($count)/l(2)" | bc -l | awk '{printf "%d\n", $1}') ))

        # 移除 IP 地址的防火墙规则
        sudo firewall-cmd --permanent --zone=public --remove-rich-rule="rule family='ipv4' source address='$ip/$mask' port port='$PORT' protocol='tcp' accept"
    done < "$IP_FILE"

    # 重新加载 firewalld 的规则
    sudo firewall-cmd --reload

    echo "已成功移除针对泰国 IP 地址的防火墙规则，现在所有 IP 地址都可以通过端口 $PORT 访问。"
else
    echo "IP 文件 $IP_FILE 不存在，无需移除规则。"
fi

